<?xml version="1.0" encoding="UTF-8"?>
<%@page import="java.lang.*"%>
<%@page import="java.util.logging.Logger"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.List"%>
<%@page import="symc.er.utils.Forecasting.ForecasterWrapper"%>
<%@page import="symc.er.utils.Forecasting.StatUtils"%>
<%@page import="symc.er.utils.DBConnection.DBConnection"%>
<%@page import="java.util.Calendar"%>
<%@page import="java.util.Date"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.logging.FileHandler"%>
<%@page import="java.util.logging.Level"%>
<%@page import="java.util.logging.Logger"%>



<%
//Initilizing logger
Logger vssLogger = null;
// Initilizing DB Connection
DBConnection dBConnection=new DBConnection();
FileHandler handler = new FileHandler(dBConnection.getPathFromRegistry("InstallDir")+"/Cognos/logs/forecasting.log");
handler.setFormatter(new java.util.logging.SimpleFormatter());
handler.setLevel(Level.ALL);
vssLogger = Logger.getLogger("forecasting");
vssLogger.addHandler(handler);
vssLogger.log(Level.INFO, "Logger initialization sucessfull");
dBConnection.initLogger(vssLogger);
//Enable this flag to consider deleted object that were rolled up earlier for forecasting.
//Consider deleted objects at enterprise or object attribute level then: "considerDeletedObjects=1"
int considerDeletedObjects=0;

//Getting user parameters form request
String Object_name="";
String ObjectType = request.getParameter("ObjectType");
ObjectType=ObjectType+"";
ObjectType=ObjectType.substring(1,ObjectType.length()-1);
if(ObjectType.equals("testValue"))
	ObjectType="HOST";
vssLogger.log(Level.INFO, "Object Type"+ObjectType);

String capacityParam = request.getParameter("capacityParam");
capacityParam=capacityParam+"";
capacityParam=capacityParam.substring(1,capacityParam.length()-1);
if(capacityParam.equals("testValue"))
	capacityParam="ALLOCATED";
vssLogger.log(Level.INFO, "Capacity"+capacityParam);
// 0=Enterprise; 1:Individual Object Instance;  2:Business View;  3:Object Attributes
String groupBy = request.getParameter("group_By");
groupBy=groupBy+"";
groupBy=groupBy.substring(1,groupBy.length()-1);
if(groupBy.equals("testValue"))
	groupBy="0";
vssLogger.log(Level.INFO, "groupBy"+groupBy);


String objectname = request.getParameter("objectname");
String objectAttrGrouping="";
int startingPoint=0;
objectname=objectname+"";
objectname=objectname.substring(1,objectname.length()-1);
if(objectname.equals("testValue"))
	objectname="0";
vssLogger.log(Level.INFO, "Ojject"+objectname);
String[] temp;  
/* delimiter */
  String delimiter = ",";
  /* given string will be split by the argument delimiter provided. */
  temp = objectname.split(",");
  if(groupBy.equals("3")){
	objectAttrGrouping=temp[0];
	startingPoint=1;
  }
vssLogger.log(Level.INFO,"temp.length"+temp.length);
 /* print substrings */
String p_frequency = request.getParameter("frequency");
p_frequency=p_frequency+"";
p_frequency=p_frequency.substring(1,p_frequency.length()-1);
if(p_frequency.equals("testValue"))
	p_frequency="1";
vssLogger.log(Level.INFO, "Freq"+p_frequency);
int int_P_Freq=Integer.parseInt(p_frequency);
//Parsing the frequency and required datapoints
int reqDP=5;
int frequency=1;
int dayIncCount=1;
switch (int_P_Freq){
	case 1:frequency=1;
			reqDP=15;
			dayIncCount=1;
	break;
	case 2:frequency=2;
			reqDP=4	;
			dayIncCount=1;
	break;
	case 3:frequency=2;
			reqDP=12;
			dayIncCount=1;
	break;
	case 4:frequency=3;
			reqDP=6;
			dayIncCount=1;
	break;
	case 5:frequency=3;
			reqDP=9;
			dayIncCount=1;
	break;
	case 6:frequency=3;
			reqDP=12;
			dayIncCount=1;
	break;

	case 7:frequency=3;
			reqDP=18;
			dayIncCount=1;
	break;

		}


%>
		<dataset xmlns="http://developer.cognos.com/schemas/xmldata/1/" xmlns:xs="http://www.w3.org/2001/XMLSchema-instance">
			<metadata>
				<item name="Date" type="xs:string" length="120"/>
				<item name="Group_By" type="xs:string" length="120"/>
				<item name="Past Capacity" type="xs:double"/>
				<item name="Forecasted Capacity" type="xs:double"/>
				<item name="Lower" type="xs:double"/>
				<item name="Upper" type="xs:double"/>
			</metadata>
			<data>
		<%	
try{
//Connecting to DB
int success=dBConnection.connectToDatabase();
if(success==1)
{ vssLogger.log(Level.INFO, "Connection failed");}
else {
	vssLogger.log(Level.INFO, "got Connection ");
	 for(int sr =startingPoint; sr < temp.length ; sr++){
		 // Initilizing Forecaster wrapper

	ForecasterWrapper forecasterWrapper	=new ForecasterWrapper(vssLogger);
	double val= 0;
	int maxIndependentDP=0;
	Date maxDate=new Date();
	Date prevDate=null;
	int count=1;
	//Getting actual data based on passed parameters (passing object type, capacity, grouping, frequency, past datapoints, object id)
	List queryResult=new ArrayList();
	//Get object name
	String objectName="";
	if(groupBy.equals("0"))
		objectName="Enterprise";
	else{if(groupBy.equals("3"))
			objectName=temp[sr];
			else
			objectName=dBConnection.getObjectName(ObjectType, temp[sr],groupBy);
	}
	//if(ObjectType.equals("DATABASES"))
		//ObjectType="DATABASE";
	queryResult=dBConnection.getResultSet(ObjectType,capacityParam,groupBy,frequency,10,temp[sr],objectAttrGrouping,considerDeletedObjects);
	//ResultSet rs = stmtqry.executeQuery("select ALLOCATED,sahara.DATES.ADATE,sahara.HOST_CAPACITY.DATES_KEY from sahara.HOST_CAPACITY join sahara.DATES on sahara.HOST_CAPACITY.DATES_KEY=sahara.DATES.DATES_KEY where HOST_KEY=23 order by sahara.HOST_CAPACITY.DATES_KEY");
	if (queryResult != null) {
			vssLogger.log(Level.INFO, "got resultSet");
			
			ArrayList dataPoint=new ArrayList();//Storing actual datapoints
			ArrayList IndependentDataPoint=new ArrayList(); //Storing independent DP (dates key)
			ArrayList IndependentReqDP=new ArrayList();	 //For generated independent DP (new date keys)
			ArrayList datesArray=new ArrayList();  //Storing dates
			Iterator itQS = queryResult.iterator();
			while (itQS.hasNext()) {
				//values.add(rs.getString(1));
				//Building dataset
				val=(Double)(itQS.next());
				maxIndependentDP=count;
				itQS.next();
				IndependentDataPoint.add(maxIndependentDP);
				IndependentReqDP.add(maxIndependentDP);
				maxDate=(Date)(itQS.next());
				if(prevDate !=null){
					//int dateDiff=(int)((maxDate.getTime()-prevDate.getTime())/(1000 * 60 * 60 * 24));
							float diffD= (maxDate.getTime()-prevDate.getTime());
							vssLogger.log(Level.INFO, "DIFFD*****"+diffD);
							int dateDiff=(int)Math.round((diffD)/(1000 * 60 * 60 * 24)); 
							vssLogger.log(Level.INFO, "dateDiff*****"+dateDiff);
						if(frequency==2){
							count=count+dateDiff/7;
						}else{
							if(frequency==3)
								count=count+1;
							else
								count=count+dateDiff;
						}
					}
					else
						count++;
				prevDate=maxDate;
				datesArray.add(maxDate);
				dataPoint.add(val);
				
				%>
				<row>
					<value><%=maxDate%></value>
					<value><%=objectName%></value>
					<value><%=val%></value>
					<value></value>
					<value></value>
					<value></value>
				</row>
				<%
			}
			vssLogger.log(Level.INFO, "DATA POINTS"+dataPoint);
			vssLogger.log(Level.INFO, "DATA IndependentDataPoint"+IndependentDataPoint);
			List forecastedData = new ArrayList();
			try{
			//Building dataset based on actual datapoints and independent DP
			IndependentReqDP=forecasterWrapper.buildDataSet(dataPoint, IndependentDataPoint,dayIncCount);
			//Selecting best forecast method
			forecasterWrapper.selectBestForecastMethod();
			vssLogger.log(Level.INFO, "reqDP"+reqDP+"  IndependentReqDP.size()"+IndependentReqDP.size());
			int reqDP_withActual=reqDP+IndependentReqDP.size();
			//Creating independent datapoints for forecasted data
			for(int i=IndependentReqDP.size();i<=reqDP_withActual;i++){
				maxIndependentDP=maxIndependentDP+dayIncCount;
				IndependentReqDP.add(maxIndependentDP);
			}
			//Creating required datapoints 
			forecasterWrapper.createReqdDataPoints(reqDP_withActual,IndependentReqDP);
			// Use the given forecasting model to forecast values for the
            //  required (future) data points
           // System.out.println(forecaster.toString());
			
			//Forecasting 
			forecastedData=forecasterWrapper.forecastData();

			//Getting prediction intervals
			StatUtils s=new StatUtils();
			double [][] perdIntervals=s.getPredictionInterval(dataPoint, forecastedData);
 			Iterator it = forecastedData.iterator();
			//Creating date for forecasted data
			Calendar cal = Calendar.getInstance(); 
			cal.setTime(maxDate);
			int countFcastDP=1;
			while ( it.hasNext() && countFcastDP<count )
            {
				it.next();
				countFcastDP++;
			}
			countFcastDP=0;
			while ( it.hasNext() )
            {
				Double dp = (Double)(it.next());
                if(frequency==1)
					cal.add( Calendar.DATE, 1 );
				else {if(frequency==2)
						cal.add( Calendar.WEEK_OF_YEAR, 1 );
					  else
						cal.add( Calendar.MONTH, 1 );
				}
				java.sql.Date javaSqlDate = new java.sql.Date(cal.getTime().getTime());
				vssLogger.log(Level.INFO, "***SQL Date: "+javaSqlDate);
								%>
				<row>
					<value><%=javaSqlDate%></value>
					<value><%=objectName%></value>
					<value></value>
					<value><%=dp%></value>
					<value><%=perdIntervals[countFcastDP][1]%></value>
					<value><%=perdIntervals[countFcastDP][0]%></value>
				</row>
				<%
				countFcastDP++;
			}}catch(Exception e){e.printStackTrace();vssLogger.log(Level.INFO, "Exception: "+e.getMessage());}
	}
			

        //Print forecasted values
}
}
}catch (Exception e){e.printStackTrace();vssLogger.log(Level.INFO, "Exception: "+e.getMessage());}
handler.close();
%>
	</data>
</dataset>