<%-- 
 /*$Id: CSSettings.jsp,v 1.4 2012/05/04 18:34:06 ajeevagu Exp $ */
 /*$Copyright: Copyright (c) 2012 Symantec Corporation.
 /*All rights reserved.
 /*
 /*THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
 /*SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
 /*WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
 /*
 /*The Licensed Software and Documentation are deemed to be commercial
 /*computer software as defined in FAR 12.212 and subject to restricted
 /*rights as defined in FAR Section 52.227-19 "Commercial Computer
 /*Software - Restricted Rights" and DFARS 227.7202, "Rights in
 /*Commercial Computer Software or Commercial Computer Software
 /*Documentation", as applicable, and any successor regulations. Any use,
 /*modification, reproduction release, performance, display or disclosure
 /*of the Licensed Software and Documentation by the U.S. Government
 /*shall be solely in accordance with the terms of this Agreement.  $*/
--%>
    
<%@page import="java.util.Locale,
                java.util.*,
                symc.er.web.PropertyHandler,
                vrts.ob.web.view.WebConstants,                             
                vrts.ob.web.core.Environment" %>
                


<script type="text/javascript" src="plugins/ER/js/envcs.js"></script> 
<link rel="stylesheet" href="plugins/ER/css/sfm.css" type="text/css" />

<%
Environment env = (Environment) session.getAttribute(WebConstants.ENVIRONMENT);	
Locale locale = env.getCurrentLocaleID();

String anatitle = PropertyHandler.getLocalizedString("ANALYTICS_SETTINGS", locale);
anatitle = anatitle.replace(" ", "&nbsp;");

String dataRetentionTitle = PropertyHandler.getLocalizedString("TREND_DATA_RETENTION_TITLE", locale);
dataRetentionTitle = dataRetentionTitle.replace(" ", "&nbsp;");

String rollUpSettingsTitle = PropertyHandler.getLocalizedString("ROLL-UP_TITLE", locale);
rollUpSettingsTitle = rollUpSettingsTitle.replace(" ", "&nbsp;");

String esInstalledAddonsTitle = PropertyHandler.getLocalizedString("ES_INSTALLED_ADDONS", locale);
esInstalledAddonsTitle = esInstalledAddonsTitle.replace(" ", "&nbsp;");
%> 

<br/>
<!-- start title --> 
<table class=component_title cellspacing=0 id="tbl_analyticstitle_ID"><tr> 
    <td width=100%><a href='javascript:vomaenv.toggle("csanalytics");' class=componentTitle><%=anatitle%></a></td> 
    <td style="vertical-align:bottom"><a href='javascript:vomaenv.toggle("csanalytics");'>
    <DIV id='csanalytics_img'><img src='/sm/vmgmt-static/images/table_collapseButton.gif' border=0></DIV></a></td>       
</tr></table> 
<!-- end title -->
<jsp:include page="AnalyticsSettings.jsp"/>

<br/>
<table class=component_title cellspacing=0 id="tbl_dataretention_ID"><tr> 
    <td width=100%><a href='javascript:vomaenv.toggle("dataretention");' class=componentTitle><%=dataRetentionTitle%></a></td> 
    <td style="vertical-align:bottom"><a href='javascript:vomaenv.toggle("dataretention");'>
    <DIV id='dataretention_img'><img src='/sm/vmgmt-static/images/table_expandButton.gif' border=0></DIV></a></td>       
</tr></table>
<jsp:include page="DataRetentionSettings.jsp"/>

<br/>
<table class=component_title cellspacing=0 id="tbl_rollupsettings_ID"><tr> 
    <td width=100%><a href='javascript:vomaenv.toggle("rollupsettings");' class=componentTitle><%=rollUpSettingsTitle%></a></td> 
    <td style="vertical-align:bottom"><a href='javascript:vomaenv.toggle("rollupsettings");'>
    <DIV id='rollupsettings_img'><img src='/sm/vmgmt-static/images/table_expandButton.gif' border=0></DIV></a></td>       
</tr></table>
<jsp:include page="RollUpSettings.jsp"/>

<br/>
<!-- start title --> 
<table class=component_title cellspacing=0 id="tbl_dblogtitle_ID"><tr> 
    <td width=100%><a href='javascript:vomaenv.toggle("installed_addons");' class=componentTitle><%=esInstalledAddonsTitle%></a></td> 
    <td style="vertical-align:bottom"><a href='javascript:vomaenv.toggle("installed_addons");'>
	<DIV id='installed_addons_img'><img src='/sm/vmgmt-static/images/table_expandButton.gif' border=0></DIV></a></td>       
</tr></table> 
<jsp:include page="installed_addons.jsp" flush="true"/>
<!-- end title -->
